/* xns_strength.c - code to read /proc/net/wireless for xnetworkstrength.
 * Written by Gabriel Cain, gabriel-software@dreamingcrow.com
 * This program is distributed and licensed under the GNU GPL.
 */

#include "xns_strength.h"
#include <stdio.h>
#include <stdlib.h>

void xns_print_stat( struct xns_strength_stat *stat ) {
if( !stat ) {
	perror("stat was NULL");
	exit(1);
	}
printf("xns_strength_stat structure dump:\n");
printf("\tiface:\t%s\n", stat->iface );
printf("\tflags:\t%d\n", stat->flags );
printf("\tlink:\t%d\n", stat->link );
printf("\tlevel:\t%d\n", stat->level );
printf("\tnoise:\t%d\n", stat->noise );
printf("\tDropped Packets:\n");
printf("\t\tnwid: %d  crypt: %d  frag: %d  retry: %d  misc: %d\n",
	stat->dp_nwid, stat->dp_crypt, stat->dp_frag, stat->dp_retry,
	stat->dp_misc );
printf("\tmissed beacon:\t%d\n", stat->mbeacon );
}

int GetPNWStats( struct xns_strength_stat *stat ) {
FILE *fp;
int i;
char *line = (char *)malloc(256);
if( !line ) {
	perror("Unable to allocate 256 bytes for buffer.  Exiting.");
	exit(1);
	}

fp = fopen( "/proc/net/wireless", "r" );

if( !fp ) {
	perror("Could not open /proc/net/wireless");
	return 0;
	}

if( !stat ) {
	perror("pointer stat was NULL");
	return 0;
	}

fgets(line, 255, fp); /* skip two lines cuz of headers that are useless :^) */
fgets(line, 255, fp);
fgets(line, 255, fp); /* this one is the one we want. :) */
fclose(fp);

#ifdef DEBUG
printf("Testing line for data...\n");
#endif

i = sscanf(line, "%s %d %d. %d. %d. %d %d %d %d %d %d",
	stat->iface, &stat->flags, &stat->link, &stat->level, &stat->noise,
	&stat->dp_nwid, &stat->dp_crypt, &stat->dp_frag, &stat->dp_retry,
	&stat->dp_misc, &stat->mbeacon );

free(line);
#ifdef DEBUG
printf("i = %d\n", i);
#endif

if( i < 5 ) {
		perror("Malformed wireless data.  Dumping...");
		xns_print_stat( stat );
		exit(2);
		}
return 1;
}


