/* xns_strength.h - header for xns_strength.c for xnetworkstrength.
 * Written by Gabriel Cain, gabriel-software@dreamingcrow.com
 * This program is distributed and licensed under the GNU GPL.
 */

#ifndef __XNS_STRENGTH_H__
#define __XNS_STRENGTH_H__

/* This file contains the definition of the structure that contains our 
 * wireless network connection strength, as well as the functions that read 
 * /proc/net/wireless for the data. 
 */

struct xns_strength_stat {
	char 	iface[32];
	int  	flags;
	int	link, level, noise;  /* TODO: Find out the nature of those. */
	int	dp_nwid, dp_crypt, dp_frag, dp_retry, dp_misc;
	int	mbeacon;
	};

extern int GetPNWStats( struct xns_strength_stat *stat ); 
extern void xns_print_stat( struct xns_strength_stat *stat );
#endif
